/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2006 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

package com.ibm.faces.renderkit;

import javax.faces.render.Renderer;

/**
 * Marker interface for a Renderer which is Ajax aware. If a Renderer is Ajax aware then the default
 * Ajax renderer which not chage the rendering state when it is invoked.
 * 
 * @author mark_wallace@ie.ibm.com
 */
public interface AjaxRenderer {
	public Renderer getRealRenderer();
}
