/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2007 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

// ------------------------------------------
// HxClient_Constants -- JSF Client Constants
// ------------------------------------------

// Names of components, behaviors and converters
HxG_5.prototype.BHR_generic	= "generic";
HxG_5.prototype.BHR_keybind	= "keybind";
HxG_5.prototype.BHR_validate= "validate";
HxG_5.prototype.BHR_assist	= "assist";
HxG_5.prototype.BHR_focus	= "focus";
HxG_5.prototype.BHR_alert	= "alert";
HxG_5.prototype.BHR_hs		= "hs";
HxG_5.prototype.BHR_track	= "track";
HxG_5.prototype.BHR_mouseclick		= "mouseclick";
HxG_5.prototype.BHR_submitlistener	= "submitlistener";
HxG_5.prototype.BHR_ajaxgetexternal	= "ajaxgetexternal";
HxG_5.prototype.BHR_ajaxget			= "ajaxget";
HxG_5.prototype.BHR_ajaxsubmit		= "ajaxsubmit";
HxG_5.prototype.BHR_typeahead		= "typeahead";
HxG_5.prototype.BHR_roweditshowhide	= "tableroweditshowhide";
HxG_5.prototype.BHR_roweditsave 	= "tableroweditsave";
HxG_5.prototype.BHR_rowaction		= "tablerowaction";
HxG_5.prototype.BHR_rowcategory		= "tablerowcategory";

HxG_5.prototype.CMP_calendar	= "calendar";
HxG_5.prototype.CMP_section		= "section";
HxG_5.prototype.CMP_colorpicker	= "colorpicker";
HxG_5.prototype.CMP_slider		= "slider";
HxG_5.prototype.CMP_spinner		= "spinner";
HxG_5.prototype.CMP_progressbar	= "progressbar";
HxG_5.prototype.CMP_timepicker	= "timepicker";
HxG_5.prototype.CMP_datepicker	= "datepicker";
HxG_5.prototype.CMP_image		= "image";
HxG_5.prototype.CMP_twistie		= "twistie";
HxG_5.prototype.CMP_menu		= "menu";
HxG_5.prototype.CMP_submenu		= "submenu";
HxG_5.prototype.CMP_mapitem		= "mapitem";
HxG_5.prototype.CMP_dialog		= "dialog";
HxG_5.prototype.CMP_datatable	= "datatable";

// Prototype reloader that goes with the above:  If you add a component, you MUST extend the following as well:
HxG_5.prototype.AJAX_prototypeloader = function () {
	if (HxG_5.prototype.JSFDatePicker && !hX_5.JSFDatePicker) hX_5.JSFDatePicker = HxG_5.prototype.JSFDatePicker;
	if (HxG_5.prototype.JSFMonth && !hX_5.JSFMonth) hX_5.JSFMonth = HxG_5.prototype.JSFMonth;
	if (HxG_5.prototype.JSFCalendar && !hX_5.JSFCalendar) hX_5.JSFCalendar = HxG_5.prototype.JSFCalendar;
	if (HxG_5.prototype.JSFColorPicker && !hX_5.JSFColorPicker) hX_5.JSFColorPicker = HxG_5.prototype.JSFColorPicker;
	if (HxG_5.prototype.JSFDialog && !hX_5.JSFDialog) hX_5.JSFDialog = HxG_5.prototype.JSFDialog;
	if (HxG_5.prototype.JSFImage && !hX_5.JSFImage) hX_5.JSFImage = HxG_5.prototype.JSFImage;
	if (HxG_5.prototype.JSFTwistie && !hX_5.JSFTwistie) hX_5.JSFTwistie = HxG_5.prototype.JSFTwistie;
	if (HxG_5.prototype.JSFMenu && !hX_5.JSFMenu) hX_5.JSFMenu = HxG_5.prototype.JSFMenu;
	if (HxG_5.prototype.JSFSubMenu && !hX_5.JSFSubMenu) hX_5.JSFSubMenu = HxG_5.prototype.JSFSubMenu;
	if (HxG_5.prototype.JSFMenuItem && !hX_5.JSFMenuItem) hX_5.JSFMenuItem = HxG_5.prototype.JSFMenuItem;
	if (HxG_5.prototype.JSFProgressBar && !hX_5.JSFProgressBar) hX_5.JSFProgressBar = HxG_5.prototype.JSFProgressBar;
	if (HxG_5.prototype.JSFSection && !hX_5.JSFSection) hX_5.JSFSection = HxG_5.prototype.JSFSection;
	if (HxG_5.prototype.JSFBehaviorTypeahead && !hX_5.JSFBehaviorTypeahead) hX_5.JSFBehaviorTypeahead = HxG_5.prototype.JSFBehaviorTypeahead;
	if (HxG_5.prototype.JSFTimePicker && !hX_5.JSFTimePicker) hX_5.JSFTimePicker = HxG_5.prototype.JSFTimePicker;
	if (HxG_5.prototype.JSFSlider && !hX_5.JSFSlider) hX_5.JSFSlider = HxG_5.prototype.JSFSlider;
	if (HxG_5.prototype.JSFSpinner && !hX_5.JSFSpinner) hX_5.JSFSpinner = HxG_5.prototype.JSFSpinner;
	if (HxG_5.prototype.JSFDataTable && !hX_5.JSFDataTable) hX_5.JSFDataTable = HxG_5.prototype.JSFDataTable;
// FIXME: Rest of table is missing
}

HxG_5.prototype.CVT_number	= "number";
HxG_5.prototype.CVT_datetime= "datetime";
HxG_5.prototype.CVT_mask	= "mask";
HxG_5.prototype.CVT_string	= "string";

// Actions
HxG_5.prototype.ACT_FOCUS 		= "FOCUS";
HxG_5.prototype.ACT_SELECTED	= "SELECTED";
HxG_5.prototype.ACT_UNSELECTED	= "UNSELECTED";
HxG_5.prototype.ACT_SHOW		= "SHOW";
HxG_5.prototype.ACT_HIDE		= "HIDE";
HxG_5.prototype.ACT_INVERTHIDE	= "INVERTHIDE";
HxG_5.prototype.ACT_VISIBLE		= "VISIBLE";
HxG_5.prototype.ACT_INVISIBLE	= "INVISIBLE";
HxG_5.prototype.ACT_INVERTVISIBLE="INVERTVISIBLE";
HxG_5.prototype.ACT_LOCKED		= "LOCKED";
HxG_5.prototype.ACT_UNLOCKED	= "UNLOCKED";
HxG_5.prototype.ACT_INVERTLOCKED= "INVERTLOCKED";
HxG_5.prototype.ACT_NEXTTAB		= "NEXTTAB";
HxG_5.prototype.ACT_NEXTTABCLEAR= "NEXTTABCLEAR";
HxG_5.prototype.ACT_PREVTAB		= "PREVTAB";
HxG_5.prototype.ACT_PREVTABCLEAR= "PREVTABCLEAR";
HxG_5.prototype.ACT_PADLEFT		= "PADLEFT";
HxG_5.prototype.ACT_PADRIGHT	= "PADRIGHT";
HxG_5.prototype.ACT_TRIM		= "TRIM";
HxG_5.prototype.ACT_CONFIRM		= "CONFIRM";
HxG_5.prototype.ACT_ALERT		= "ALERT";
HxG_5.prototype.ACT_CLICK		= "CLICK";
HxG_5.prototype.ACT_SUBMIT		= "SUBMIT";
HxG_5.prototype.ACT_NOTHING		= "NOTHING";
HxG_5.prototype.ACT_NONE		= "NONE";
HxG_5.prototype.ACT_STOP		= "STOP";
HxG_5.prototype.ACT_GOTO		= "GOTO";
HxG_5.prototype.ACT_GET			= "GET";
HxG_5.prototype.ACT_WHILEEVENT	= "WHILEEVENT";
HxG_5.prototype.ACT_MOVE		= "MOVE";		// Not public
HxG_5.prototype.ACT_DLG_OK		= "DLG_OK";		// Not public
HxG_5.prototype.ACT_DLG_CANCEL	= "DLG_CANCEL";	// Not public
HxG_5.prototype.TGT_ATERROR		= "@ERROR";
HxG_5.prototype.TGT_ISERROR		= "ERROR";

// Class names and suffixes
//HxG_5.prototype.CLASS_TABPANEL	= "TabPanel_1-IBM_1";
//HxG_5.prototype.CLASS_TAB_HEADER	= "Header";
//HxG_5.prototype.CLASS_TAB_BODY	= "Body";
//HxG_5.prototype.CLASS_TAB_FOOTER	= "Footer";
//HxG_5.prototype.CLASS_TAB_BUTTON	= "Button";
//HxG_5.prototype.CLASS_TAB_TABACTIVE	= "TabActive";
//HxG_5.prototype.CLASS_TAB_TABINACTIVE	= "TabInactive";
HxG_5.prototype.CLASS_BUTTON_LABEL	= "_Label";
HxG_5.prototype.CLASS_BUTTON_ICON	= "_Icon";
HxG_5.prototype.CLASS_BUTTON_MOUSED	= "_moused";
HxG_5.prototype.CLASS_BUTTON_DEPRSD	= "_depressed";
HxG_5.prototype.CLASS_BUTTON_DISBLD	= "_disabled";
HxG_5.prototype.CLASS_DEF			= "inputText";
HxG_5.prototype.CLASS_SL			= "_Slider";
HxG_5.prototype.CLASS_SL_LINES		= "_Body";
HxG_5.prototype.CLASS_DP			= "_DatePicker";
HxG_5.prototype.CLASS_DPS			= ["-Header", "-HeaderLine1", "-HeaderLine2", "-HeaderYear", "-HeaderMonth", "-HeaderWeekday", 
										"-Body", "-Button", "-Hover", "-CurrentMonth", "-OtherMonth", "-CurrentDay", "-InvalidDay", "-Today", "-CurrentToday",  "-Size"];
HxG_5.prototype.CLASS_CA			= "inputMiniCalendar";
HxG_5.prototype.CLASS_DEFC			= "selectOneColor";
HxG_5.prototype.CLASS_CLR			= "_ColorPicker";
HxG_5.prototype.CLASS_CLRS			= ["-Body", "-GridCell", "-GridSwatch", "-GridCell-Selected", "-GridCell-Hover","-GridCell-Hover-Selected"];
HxG_5.prototype.CLASS_TP			= "_TimePicker";
HxG_5.prototype.CLASS_TPS			= ["-Body", "-GridCell", "-GridSwatch", "-GridCell-Selected", "-GridCell-Hover","-GridCell-Hover-Selected"];
HxG_5.prototype.CLASS_PB			= "progressBar"; 
HxG_5.prototype.CLASS_PBS			= ["-Table", "-Message", "-Bar", "-Bar_container", "-Bar_text"];
HxG_5.prototype.CLASS_TA			= "_Typeahead";
HxG_5.prototype.CLASS_TAS			= ["-List", "-Item", "-Item-Selected"];
HxG_5.prototype.CLASS_DLG			= ["_TitleBar", "_TitleBar-CloseButton", "_TitleBar-CloseButton-img", "_ContentArea", "_Footer"];

HxG_5.prototype.CLASS_MB_SEPARATOR	= "separator";
HxG_5.prototype.CLASS_MB_SEPARATOR_L= "separator_first";
HxG_5.prototype.CLASS_MB_SEPARATOR_R= "separator_last";
HxG_5.prototype.CLASS_MB_CELL		= "cell";
HxG_5.prototype.CLASS_MB_ALTCELL	= "cell_alt";
HxG_5.prototype.CLASS_MB_CELLF		= "cell_first";
HxG_5.prototype.CLASS_MB_CELLL		= "cell_last";
HxG_5.prototype.CLASS_MB_ITEM		= "item";
HxG_5.prototype.CLASS_MB_ALTITEM	= "item_alt";
HxG_5.prototype.CLASS_MB_ARROW		= "arrow";
HxG_5.prototype.CLASS_MB_N	= "_normal";
HxG_5.prototype.CLASS_MB_M	= "_moused";
HxG_5.prototype.CLASS_MB_S	= "_selected";
HxG_5.prototype.CLASS_MB_SM	= "_selected_moused";
HxG_5.prototype.CLASS_MB_D	= "_disabled";

// Defaults for a datetime converter
HxG_5.prototype.DTFMT_DATE0			= "MM-dd-yyyy";
HxG_5.prototype.DTFMT_DEFAULTSTRICT	= 1;
HxG_5.prototype.DTFMT_DEFAULTFIRSTDAYWEEK	= 0;
HxG_5.prototype.DTFMT_YEAR			= "%yyyy";
HxG_5.prototype.DTFMT_GEYEAR		= "%GGGG %y";
HxG_5.prototype.DTFMT_GCYEAR		= "%yyyy %GG";

// Defaults for a mask converter
HxG_5.prototype.MFMT_DEFAULTSTRICT = 1;

// Western Digit constants for numbers/dates/masks
HxG_5.prototype.WDIGITS = "0123456789";	// Western (Latin) digits 0 thru 9

// Default char types for mask converter
HxG_5.prototype.MASK_ALPHA = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

// Dates: Identifiers for kinds of epochs (see strings for epoch definitions)
HxG_5.prototype.DATE_EPOCH_IDS   = ["","i","h","b","j"];	// "BC/AD", Islamic (Hijiri), Hebrew, Buddhist, Japanese Y-of-E 
HxG_5.prototype.DATE_EPOCH_YEARS = [
// Christian Gregorian Calendar, two epochs -- religious form
[0,0],
// Hijiri (Islamic)Calendar, one epoch -- the date of the haj = July 16 622 CE ("civil" scheme, other schemes use July 15)
["06220716","006220716"],
// Hebrew Calendar - open epoch -- the start of the world, just before midnight October 6, 3761 BC
["-37611006","-37611006"],
// Buddhist Gregorian Calendar, one epoch -- the birth of The Buddha (Jan 1 543 BC)
["-05430101","-05430101"],
// Japanese Gregorian Calendar, reigns of the emperors -- Meiji period and later
["18680908","19120731","19261226","19890108"]
];

// Dates Constants:  Today and the days before and after it
HxG_5.prototype.STR_DATE_TODAY = ["today","tomorrow","yesterday","now"];

// Date/Time Constants:  Legal pattern characters
HxG_5.prototype._uA = "A";	HxG_5.prototype._u2A = "AA";  HxG_5.prototype._u3A = "AAA";  HxG_5.prototype._u4A = "AAAA";  HxG_5.prototype._u5A = "AAAAA";  HxG_5.prototype._u6A = "AAAAAA";  HxG_5.prototype._u7A = "AAAAAAA";  HxG_5.prototype._u8A = "AAAAAAAA";
HxG_5.prototype._lG = "g";	HxG_5.prototype._l2G = "gg";  HxG_5.prototype._l3G = "ggg";  HxG_5.prototype._l4G = "gggg";  HxG_5.prototype._l5G = "ggggg";  HxG_5.prototype._l6G = "gggggg";  HxG_5.prototype._l7G = "ggggggg";  HxG_5.prototype._l8G = "gggggggg";
HxG_5.prototype._lY = "y";  HxG_5.prototype._l2Y = "yy";  HxG_5.prototype._l3Y = "yyy";  HxG_5.prototype._l4Y = "yyyy";
HxG_5.prototype._uY = "Y";  HxG_5.prototype._u2Y = "YY";  HxG_5.prototype._u3Y = "YYY";  HxG_5.prototype._u4Y = "YYYY";
HxG_5.prototype._uG = "G";  HxG_5.prototype._u2G = "GG";  HxG_5.prototype._u3G = "GGG";  HxG_5.prototype._u4G = "GGGG";
HxG_5.prototype._uM = "M";  HxG_5.prototype._u2M = "MM";  HxG_5.prototype._u3M = "MMM";  HxG_5.prototype._u4M = "MMMM";
HxG_5.prototype._uE = "E";  HxG_5.prototype._u2E = "EE";  HxG_5.prototype._u3E = "EEE";  HxG_5.prototype._u4E = "EEEE";
HxG_5.prototype._uD = "D";  HxG_5.prototype._u2D = "DD";  HxG_5.prototype._u3D = "DDD";
HxG_5.prototype._uS = "S";  HxG_5.prototype._u2S = "SS";  HxG_5.prototype._u3S = "SSS";
HxG_5.prototype._lD = "d";  HxG_5.prototype._l2D = "dd";
HxG_5.prototype._lH = "h";  HxG_5.prototype._l2H = "hh";
HxG_5.prototype._uH = "H";  HxG_5.prototype._u2H = "HH";
HxG_5.prototype._lM = "m";  HxG_5.prototype._l2M = "mm";
HxG_5.prototype._lS = "s";  HxG_5.prototype._l2S = "ss";
HxG_5.prototype._uK = "K";  HxG_5.prototype._u2K = "KK";
HxG_5.prototype._lK = "k";  HxG_5.prototype._l2K = "kk";
HxG_5.prototype._lW = "w";  HxG_5.prototype._l2W = "ww";
HxG_5.prototype._uF = "F";
HxG_5.prototype._uW = "W";
HxG_5.prototype._lE = "e";
HxG_5.prototype._lA = "a";
HxG_5.prototype._lZ = "z";
HxG_5.prototype._uZ = "Z";
HxG_5.prototype._lX = "x";
HxG_5.prototype._lN = "n";
HxG_5.prototype._lP = "p";
HxG_5.prototype._lF = "f";
HxG_5.prototype._lL = "l";
HxG_5.prototype._uR = "R";

// Defaults for a number converter
HxG_5.prototype.NFMT_DECIMAL0 = "###,###,##0";
HxG_5.prototype.NFMT_LOCALE0  = ",.%\u2030-$";
HxG_5.prototype.NFMT_DEFAULTSTRICT	= 1;

// Defaults for drawing twisties
HxG_5.prototype.TW_UP = 0;
HxG_5.prototype.TW_DN = 1;
HxG_5.prototype.TW_LT = 2;
HxG_5.prototype.TW_RT = 3;
HxG_5.prototype.TW_SNOUT = 0;
HxG_5.prototype.TW_PUG = 1;
HxG_5.prototype.TW_VEE = 2;
HxG_5.prototype.TW_TRI = 3;
HxG_5.prototype.TW_NOBAR = 0;
HxG_5.prototype.TW_BAR_INNER = 1;
HxG_5.prototype.TW_BAR_OUTER = 2;

// Tags used in media component scripts
HxG_5.prototype.TAG_OBJECT = "object";
HxG_5.prototype.TAG_PARAM = "param";
HxG_5.prototype.TAG_EMBED = "embed";

// HTML Node types
HxG_5.prototype.ELEMENT_NODE	= 1;
HxG_5.prototype.TEXT_NODE		= 3;
HxG_5.prototype.DOCUMENT_NODE	= 9;

// HTML/DOM Keycodes
HxG_5.prototype.KEY_BS		= 8;
HxG_5.prototype.KEY_TAB		= 9;
HxG_5.prototype.KEY_ENTER	= 13;
HxG_5.prototype.KEY_ESC		= 27;
HxG_5.prototype.KEY_SPACEBAR= 32;
HxG_5.prototype.KEY_PGUP	= 33;
HxG_5.prototype.KEY_PGDN	= 34;
HxG_5.prototype.KEY_END		= 35;
HxG_5.prototype.KEY_HOME	= 36;
HxG_5.prototype.KEY_LTARROW	= 37;
HxG_5.prototype.KEY_UPARROW	= 38;
HxG_5.prototype.KEY_RTARROW	= 39;
HxG_5.prototype.KEY_DNARROW	= 40;
HxG_5.prototype.KEY_INS		= 45;
HxG_5.prototype.KEY_DEL		= 46;

// Selected system color names
HxG_5.prototype.CLR_BTN		= "buttonface";
HxG_5.prototype.CLR_BCK		= "Window";
HxG_5.prototype.CLR_SHDW	= "ThreeDShadow";
HxG_5.prototype.CLR_BLK		= "#000000";
HxG_5.prototype.CLR_WHT		= "#FFFFFF";

// Selected HTML abbreviations &#xA0
HxG_5.prototype.AMP_ABBS	= [["times","\u00D7"],["amp","&"],["nbsp","\u00A0"],["gt",">"],["lt","<"],["yen","\u00A5"],["copy","\u00A9"],["reg","\u00AE"],["para","\u00B6"],["pi","\u03C0"],["trade","\u2122"],["euro","\u20AC"]];

// Z-index value to put something "on top" of everything else in the page
HxG_5.prototype.BIG_ZINDEX	= 10000;

// Commonly used strings for properties/attributes
HxG_5.prototype._Z  = "0";
HxG_5.prototype._1  = "1";
HxG_5.prototype._2  = "2";
HxG_5.prototype.__1 = "-1";
HxG_5.prototype._C  = ",";
HxG_5.prototype._U = "_";
HxG_5.prototype._Y = "-";
HxG_5.prototype._P = ".";
HxG_5.prototype._B = " ";
HxG_5.prototype._E = "";
HxG_5.prototype._X = "X";
HxG_5.prototype._LB  = "#";
HxG_5.prototype._EQ  = "=";
HxG_5.prototype._QM  = "?";
HxG_5.prototype._AMP = "&";
HxG_5.prototype._EX  = "!";
HxG_5.prototype._TL  = "~";
HxG_5.prototype._SL  = "/";
HxG_5.prototype._SM  = ";";
HxG_5.prototype._CL  = ":";
HxG_5.prototype._VB  = "|";
HxG_5.prototype._SQT = "'";
HxG_5.prototype._DQT = '"';
HxG_5.prototype._LT  = "<";
HxG_5.prototype._GT  = ">";
HxG_5.prototype._PL  = "(";
HxG_5.prototype._PR  = ")";
HxG_5.prototype._PCT = "%";
HxG_5.prototype._UPC = "^";
HxG_5.prototype._ON  = "on";
HxG_5.prototype._OFF = "off";
HxG_5.prototype._FLS = "false";
HxG_5.prototype._PX  = "px";
HxG_5.prototype._ZPX = "0px";
HxG_5.prototype._1PX = "1px";
HxG_5.prototype._2PX = "2px";
HxG_5.prototype._HEX = "0x";
HxG_5.prototype._ID  = "id";
HxG_5.prototype._NAM = "name";
HxG_5.prototype._TRU = "true";
HxG_5.prototype._HX  = "_hx_";
HxG_5.prototype._lOBJ= "object";
HxG_5.prototype._UND = "undefined";
HxG_5.prototype._ALL = "all";
HxG_5.prototype._NO  = "none";
HxG_5.prototype._HI  = "hidden";
HxG_5.prototype._VS  = "visible";
HxG_5.prototype._POS = "position";
HxG_5.prototype._ABS = "absolute";
HxG_5.prototype._REL = "relative";
HxG_5.prototype._TRN = "transparent";
HxG_5.prototype._DSB = "disabled";
HxG_5.prototype._RDO = "readonly";
HxG_5.prototype._SLD = "solid";
HxG_5.prototype._OUT = "outset";
HxG_5.prototype._INS = "inset";
HxG_5.prototype._AUT = "auto";
HxG_5.prototype._DFT = "default";
HxG_5.prototype._IGN = "ignore";
HxG_5.prototype._INL = "inline";
HxG_5.prototype._INB = "inline-block";
HxG_5.prototype._BLK = "block";
HxG_5.prototype._MID = "middle";
HxG_5.prototype._CTR = "center";
HxG_5.prototype._LFT = "left";
HxG_5.prototype._RGT = "right";
HxG_5.prototype._TOP = "top";
HxG_5.prototype._BOT = "bottom";
HxG_5.prototype._NOW = "nowrap";
HxG_5.prototype._COR = "color";
HxG_5.prototype._BCOR= "background-color";
HxG_5.prototype._BRD = "border";
HxG_5.prototype._BRCOR= "border-color";
HxG_5.prototype._BRSTY= "border-style";
HxG_5.prototype._BRWID= "border-width";
HxG_5.prototype._BRLWD= "border-left-width";
HxG_5.prototype._BRRWD= "border-right-width";
HxG_5.prototype._BRTWD= "border-top-width";
HxG_5.prototype._BRBWD= "border-bottom-width";
HxG_5.prototype._BRLCL= "border-left-color";
HxG_5.prototype._BRRCL= "border-right-color";
HxG_5.prototype._BRTCL= "border-top-color";
HxG_5.prototype._BRBCL= "border-bottom-color";
HxG_5.prototype._BRLSY= "border-left-style";
HxG_5.prototype._BRRSY= "border-right-style";
HxG_5.prototype._BRTSY= "border-top-style";
HxG_5.prototype._BRBSY= "border-bottom-style";
HxG_5.prototype._BIMG = "background-image";
HxG_5.prototype._BPOS = "background-position";
HxG_5.prototype._BREP = "background-repeat";
HxG_5.prototype._NREP = "no-repeat";
HxG_5.prototype._ZUF = "-moz-user-focus";
HxG_5.prototype._WD	= "width";
HxG_5.prototype._HT = "height";
HxG_5.prototype._ALT= "alt";
HxG_5.prototype._TTL= "title";
HxG_5.prototype._SRC= "src";
HxG_5.prototype._TYP= "type";
HxG_5.prototype._XT = "text";
HxG_5.prototype._VIS = "visibility";
HxG_5.prototype._DSP = "display";
HxG_5.prototype._OFW = "overflow";
HxG_5.prototype._ZND = "z-index";
HxG_5.prototype._FSZ = "font-size";
HxG_5.prototype._MGNL= "margin-left";
HxG_5.prototype._MGNR= "margin-right";
HxG_5.prototype._MGNT= "margin-top";
HxG_5.prototype._MGNB= "margin-bottom";
HxG_5.prototype._PADL= "padding-left";
HxG_5.prototype._PADR= "padding-right";
HxG_5.prototype._PADT= "padding-top";
HxG_5.prototype._PADB= "padding-bottom";
HxG_5.prototype._TXA = "text-align";
HxG_5.prototype._VXA = "vertical-align";
HxG_5.prototype._CRS = "cursor";
HxG_5.prototype._PTR = "pointer";
HxG_5.prototype._URL = "url(";
HxG_5.prototype._URI = "uri(";
HxG_5.prototype._BODY= "#body";
HxG_5.prototype._DOC = "#document";
HxG_5.prototype._WDW = "#window";
HxG_5.prototype._RAD = "radio";
HxG_5.prototype._CHK = "checkbox";
HxG_5.prototype._FIL = "file";
HxG_5.prototype._SBM = "submit";
HxG_5.prototype._RES = "reset";
HxG_5.prototype._PWD = "password";
HxG_5.prototype._TBTN= "button";
HxG_5.prototype._lIMG= "image";
HxG_5.prototype._lINP= "input";
HxG_5.prototype._VL	 = "value";
HxG_5.prototype._LTR = "ltr"; // values for dir attribute
HxG_5.prototype._RTL = "rtl"; // values for dir attribute
HxG_5.prototype._onKD= "onkeydown";
HxG_5.prototype._evKD= "keydown";
HxG_5.prototype._onKU= "onkeyup";
HxG_5.prototype._evKU= "keyup";
HxG_5.prototype._onKP= "onkeypress";
HxG_5.prototype._evKP= "keypress";
HxG_5.prototype._onMC= "onclick";
HxG_5.prototype._evMC= "click";
HxG_5.prototype._onMCC="ondblclick";
HxG_5.prototype._evMCC="dblclick";
HxG_5.prototype._onMU= "onmouseup";
HxG_5.prototype._evMU= "mouseup";
HxG_5.prototype._onMD= "onmousedown";
HxG_5.prototype._evMD= "mousedown";
HxG_5.prototype._onMM= "onmousemove";
HxG_5.prototype._evMM= "mousemove";
HxG_5.prototype._onMV= "onmouseover";
HxG_5.prototype._evMV= "mouseover";
HxG_5.prototype._onMO= "onmouseout";
HxG_5.prototype._evMO= "mouseout";
HxG_5.prototype._onIN= "oninput";
HxG_5.prototype._onMS= "onmouse";
HxG_5.prototype._onPK= "onpoke";
HxG_5.prototype._onPC= "onpropertychange";
HxG_5.prototype._onDOMPC = "DOMAttrModified";
HxG_5.prototype._onDOMVPC= "DOMCharacterDataModified";
HxG_5.prototype._onR = "onresize";
HxG_5.prototype._evR = "resize";
HxG_5.prototype._onF = "onfocus";
HxG_5.prototype._evF = "focus";
HxG_5.prototype._onB = "onblur";
HxG_5.prototype._evB = "blur";
HxG_5.prototype._onL = "onload";
HxG_5.prototype._onUL= "onunload";
HxG_5.prototype._onC = "onchange";
HxG_5.prototype._onSC= "onscroll";
HxG_5.prototype._evSC= "scroll";
HxG_5.prototype._onCM= "oncontextmenu";
HxG_5.prototype._evCM= "contextmenu";
HxG_5.prototype._onCP = "oncopy";
HxG_5.prototype._evCP = "copy";
HxG_5.prototype._onCT = "oncut";
HxG_5.prototype._evCT = "cut";
HxG_5.prototype._onPST= "onpaste";
HxG_5.prototype._evPST= "paste";

// -- Constant Defs for individual components
// -- Panel Section
HxG_5.prototype._SECTIONHEADERANCHOR_OPENED_ID="_SECTIONHEADER_OPENED";
HxG_5.prototype._SECTIONHEADERANCHOR_CLOSED_ID="_SECTIONHEADER_CLOSED";
HxG_5.prototype._SECTIONHEADER_OPENED_ID="_TITLE_OPENED";
HxG_5.prototype._SECTIONHEADER_CLOSED_ID="_TITLE_CLOSED";
HxG_5.prototype._SECTIONHEADER_TITLE="_TITLE";
// -- Calendar
HxG_5.prototype.CAL_extra_id_for_input = "_INPUT";
// -- Dialog
HxG_5.prototype.DLG_CANCEL			= "CANCEL";
HxG_5.prototype.DLG_OK				= "OK";
HxG_5.prototype.DLG_modal			= "modal";
HxG_5.prototype.DLG_modeless		= "modeless";
HxG_5.prototype.DLG_ContentAreaSuffix= "_ca";
HxG_5.prototype.DLG_TitleBarSuffix	= "_tb";
HxG_5.prototype.DLG_CloseButtonSuffix= "_cb";
HxG_5.prototype.DLG_CloseButtonImgSuffix= "_cbi";
HxG_5.prototype.DLG_IFrameSuffix	= "_if";
// -- Image (button)
HxG_5.prototype.IMG_NORMAL = 0;
HxG_5.prototype.IMG_MOUSED = 1;
HxG_5.prototype.IMG_DEPRESSED = 2;
HxG_5.prototype.IMG_DISABLED = 3;

// Tagnames -- upper-cased except in strict XML case where they are lower-cased
//if (document.contentType && document.contentType == "application/xhtml+xml") {
if (document && document.createElement && ((document.createElement("button")).tagName == "button")) {
	HxG_5.prototype.tagCase = function (s) {return s.toLowerCase();}
} else {
	HxG_5.prototype.tagCase = function (s) {return s.toUpperCase();}
}
HxG_5.prototype._BBODY	= HxG_5.prototype.tagCase("body");
HxG_5.prototype._DDOC	= HxG_5.prototype.tagCase("document");
HxG_5.prototype._TAB	= HxG_5.prototype.tagCase("table");
HxG_5.prototype._TBDY	= HxG_5.prototype.tagCase("tbody");
HxG_5.prototype._THED	= HxG_5.prototype.tagCase("thead");
HxG_5.prototype._TD		= HxG_5.prototype.tagCase("td");
HxG_5.prototype._TR 	= HxG_5.prototype.tagCase("tr");
HxG_5.prototype._DIV	= HxG_5.prototype.tagCase("div");
HxG_5.prototype._INP	= HxG_5.prototype.tagCase("input");
HxG_5.prototype._TXT	= HxG_5.prototype.tagCase("textarea");
HxG_5.prototype._BTN	= HxG_5.prototype.tagCase("button");
HxG_5.prototype._IMG	= HxG_5.prototype.tagCase("img");
HxG_5.prototype._SEL	= HxG_5.prototype.tagCase("select");
HxG_5.prototype._OPT	= HxG_5.prototype.tagCase("option");
HxG_5.prototype._SPN	= HxG_5.prototype.tagCase("span");
HxG_5.prototype._FRM	= HxG_5.prototype.tagCase("form");
HxG_5.prototype._ANC	= HxG_5.prototype.tagCase("a");
HxG_5.prototype._EMB	= HxG_5.prototype.tagCase("embed");
HxG_5.prototype._OBJ	= HxG_5.prototype.tagCase("object");
HxG_5.prototype._APP	= HxG_5.prototype.tagCase("applet");
HxG_5.prototype._BR		= HxG_5.prototype.tagCase("br");
HxG_5.prototype._HR		= HxG_5.prototype.tagCase("hr");
HxG_5.prototype._IFRM	= HxG_5.prototype.tagCase("iframe");
HxG_5.prototype._LAB	= HxG_5.prototype.tagCase("label");
HxG_5.prototype._SCR	= HxG_5.prototype.tagCase("script");
HxG_5.prototype._HEAD	= HxG_5.prototype.tagCase("head");
HxG_5.prototype._HHTML	= HxG_5.prototype.tagCase("html");

//-----------------------------------------------------------------------------------------------
// NON TRANSLATABLE Internal Error messages
//-----------------------------------------------------------------------------------------------
HxG_5.prototype.INTERR_Dispatcher	= "Internal Error: Cannot dispatch user function.";
HxG_5.prototype.INTERR_Constraint	= "Internal error: Cannot consruct constraint.";
HxG_5.prototype.INTERR_Bad_Family	= "Internal error: Invalid stylesheet family.";
HxG_5.prototype.INTERR_Parse_Literal= "Parse error: Failed parsing a strict literal: ";
HxG_5.prototype.INTERR_Parse_TwoDig	= "Parse error: Failed parsing number digits: ";
HxG_5.prototype.INTERR_Parse_end	= "Parse error: Failing at end of parse: ";
HxG_5.prototype.INTERR_Format_Symbol	= "Bad format: Unexpected number symbol.";
HxG_5.prototype.INTERR_Format_ZSymbol	= "Bad format: Unexpected 0 symbol.";
HxG_5.prototype.INTERR_Format_LSymbol	= "Bad format: Unexpected # symbol.";
HxG_5.prototype.INTERR_Format_Group		= "Bad format: Bad grouping character: ";
HxG_5.prototype.INTERR_Format_Decimal	= "Bad format: Multiple decimal points.";
HxG_5.prototype.INTERR_Format_Exponent	= "Bad format: Bad exponent marker.";
HxG_5.prototype.INTERR_Format_Padding	= "Bad format: Incorrect use of padding marker.";
HxG_5.prototype.INTERR_Format_Percent	= "Bad format: Cannot have percent and mille.";
HxG_5.prototype.INTERR_Empty_Palette	= "Bad definition: Palette content is empty.";
HxG_5.prototype.INTERR_bc_timeout 		= "Page reload error: unable to retrieve additional data (request timed out).";
HxG_5.prototype.INTERR_bc_baddata 		= "Page reload error: illformed data sent from server.";
HxG_5.prototype.INTERR_bc_badpanel		= "Page reload error: request not issued against a panel.";
//xmldata internal error messages
HxG_5.prototype.INTERR_invalid_param 			= "Required parameter '{0}' is null or 'undefined'";
HxG_5.prototype.INTERR_invalid_param_type 		= "Type of parameter '{0}' is invalid";
HxG_5.prototype.INTERR_xmldata_not_element 		= "XMLData object must represent node of type 'element'";
HxG_5.prototype.INTERR_invalid_index 			= "Index out of bounds";
HxG_5.prototype.INTERR_xml_str_type 			= "XMLData must only contain objects representing nodes of type 'element', 'comment', 'attribute' or 'text'";

//-----------------------------------------------------------------------------------------------
// NON TRANSLATABLE NUMBER FORMAT LITERALS FOLLOW
//-----------------------------------------------------------------------------------------------
HxG_5.prototype.STR_percent_char	= "%"; 		// "%";	// DO NOT TRANSLATE THIS LINE = \u2030
HxG_5.prototype.STR_mille_char		= "\u2030"; // "";	// DO NOT TRANSLATE THIS LINE = \u2030
HxG_5.prototype.STR_icurrency_char	= "\u00A4"; //"";	// DO NOT TRANSLATE THIS LINE = \u00A4
