/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2006 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

// ------------------------
// JSF Client Global Object 
// ------------------------
function HxG_5 () {
	this.version	= "4.00";						/* Public: Version of this structure */

	this.brw		= new this.HxBrowserMgr();		/* Public: Browser information */
	this.brw.initClientBrowserObject(this);

	this.g			= new this.HxGeometryMgr(this);	/* Public: Geometry management */
	this.ifr		= new this.HxIFrameMgr(this);	/* Public: IFrame management */
	this.res		= [];							/* Private: Built-in resources such as images */
	this.i			= new this.HxCompImpMgr(this);	/* Private: Component implementation */
	this.popMgr		= new this.HxPopMgr(this);		/* Private: Popup manager */
	this.mouser		= new this.HxMouseMgr(this);	/* Private: Mouse manager */
	this.uistate	= new this.HxUIState();			/* Private: UI State */
	this.Components	= [];							/* Private: Components being managed */
	this.SubComponents=[];							/* Private: Subcomponents being managed */
	this.Behaviors	= [];							/* Private: Behaviors being managed */
	this.Converters = [];							/* Private: Converters being managed */
	this.Validators	= [];							/* Private: Validators being managed */
	this.HTMLTags	= [];							/* Private: HTML tags being managed */
	this.Popups		= [];							/* Private: Popups being managed */
	this.DialogStack= [];							/* Private: Stack of Dialogs sorted in z-order @vadimAdd */
	this.ifr		= new this.HxIFrameMgr();		/* Private: Iframe manager */
	this.Timers		= [];							/* Private: Timers being managed */
	this.ObjTimers	= [];							/* Private: Object Timers being managed */
	this.userEvents	= [];							/* Private: User event handlers */
	this.regExp		= new this.HxConstraints();		/* Private: Registered constraints */
	this.sel		= new this.HxCaretSelection();	/* Private: Caret selection management */
	this.tabNav		= null;							/* Private: Next/Previous field navigator */
	this.c			= new this.HxCache();			/* Private: Cached calculations */
	this.clip		= new this.pseudoClipboard();	/* Private: fake clipboard object */
	this.action		= new this.HxAction();			/* Private: used to run an hxAction */
	this.CSSSelectors=null;							/* Private: CSS classes on the page */
	this.cal		= new this.HxICal();			/* Private: Internationalized calendar fcns */
	this.col		= new this.HxICol();			/* Private: Internationalized color fcns */
	this.Topics		= [];							/* Private: Topics that have been subscribed to */
	this.locales	= [];							/* Private: Array of active locales */
	this.L			= [];							/* Private: Array of locale-specific strings */
	this.mustDestroy= [];							/* Private: Memory-hogging objects that need destruction in page unload in IE6 */

	// Mark the pageload manager as not done
	this.bodyLoadRewritten = false;
	this.bodyLoadDone = false;
	this.bodyLoadRedrawA = false;
	this.bodyLoadRedrawB = false;
	this.isPortal	= false;						/* Private: Is hX running in a portal-generated page? */

	// Some global state detections
	this.timerUnq = 999;
	this.topicUnq = 999;
	this.globalResize = false;
	this.pendingFocusReturn = null;
	this.skipVCMonitor = false;
	this.pendingSelect = false;
	this.pendingBlurRefocus = null;
	this.pendingPrompt = null;
	this.cursorTracking = null;
}
