/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2006 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

// hxclient_XSLTProcessor_v5.js


HxG_5.prototype.XSLTProcessor = function(xslStylesheet)
{
     this._xslStylesheet = xslStylesheet;
}


HxG_5.prototype.XSLTProcessor.prototype.setStylesheet = function(xslStylesheet)
{
	this._xslStylesheet = xslStylesheet;
}

HxG_5.prototype.XSLTProcessor.prototype.transformToFragment = function(xmlDoc)
{
      if (window.XSLTProcessor)
      {
                
           var xsltProcessor = new XSLTProcessor();
           xsltProcessor.importStylesheet(xslStylesheet);
			
           var output = xsltProcessor.transformToFragment(xmlDoc, document);

                
      }
      else if(window.ActiveXObject)
      {
			
        	var xml = new ActiveXObject("Microsoft.XMLDOM");
			xml.async = false;
			xml.load(xmlDoc);
				
			var xsl = new ActiveXObject("Microsoft.XMLDOM");
			xsl.async = false;
			xsl.load(xslStylesheet);
			
			var output = xml.transformNode(xsl);
		     
      }
	
	  return output;

}

